#include <iostream>
#include <cstring>


#include <AlibException.h>
#include <regexp/RegExp.h>
#include <regexp/RegExpParser.h>
#include <regexp/RegExpSymbol.h>
#include <sax/SaxInterface.h>

#include "RegExpDerivation.h"


using namespace alib;
using namespace regexp;
using namespace std;

void help( void )
{
    cout << "aderivation 0.01" << endl;
    cout << "Returns derivation of regexp over given string of symbols." << endl;
    cout << "Usage: aintegral SYMBOL-1 SYMBOL-2 ... SYMBOL-n" << endl;
}

int main(int argc, char** argv)
{
    for( int i = 0; i < argc; i++ )
    {
        if( strcmp( argv[ i ], "--help" ) == 0 || strcmp( argv[ i ], "-h" ) == 0 )
        {
            help( );
            return 0;
        }
    }

    try
    {
        list<Token> tokens;
        string input(istreambuf_iterator<char>(cin), (istreambuf_iterator<char>()));
        SaxInterface::parseMemory(input, tokens);
        RegExp re = RegExpParser::parse(tokens);

        list<Symbol> dString;
        for( int i = 1; i < argc ; i++ )
        {
            string symbol( argv[ i ] );
            // cout << "'" << symbol << "'" << endl;
            dString.push_back( Symbol( symbol ) );
        }
        RegExpDerivation d( re );
        d.derivation( dString ).toXML( cout );
    }
    catch( AlibException & e )
    {
        cout << e.what() << endl;
        return 1;
    }

    return 0;
}
